<?php
/*
* SetDebug.php - A simple module to change the debug flag.
*
* BeBot - An Anarchy Online & Age of Conan Chat Automaton
* Copyright (C) 2004 Jonas Jax
* Copyright (C) 2005-2007 Thomas Juberg Stenss, ShadowRealm Creations and the BeBot development team.
*
* Developed by:
* - Alreadythere (RK2)
* - Blondengy (RK1)
* - Blueeagl3 (RK1)
* - Glarawyn (RK1)
* - Khalem (RK1)
* - Naturalistic (RK1)
* - Temar (RK1)
*
* See Credits file for all aknowledgements.
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; version 2 of the License only.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
*  USA
*
* File last changed at $LastChangedDate: 2009-01-04 18:47:30 +0000 (Sun, 04 Jan 2009) $
* Revision: $Id: SetDebug.php 92 2009-01-04 18:47:30Z temar $
*/


$setdebug = new SetDebug($bot);

/*
The Class itself...
*/
class SetDebug extends BaseActiveModule
{
	function __construct(&$bot)
	{
		parent::__construct(&$bot, get_class($this));

		$this -> register_command('tell', 'setdebug', 'OWNER');
	}

	function command_handler($name, $msg, $origin)
	{
		$this -> bot -> debug = !$this -> bot -> debug;
		if ($this -> bot -> debug)
		{
			return "Debugging output enabled!";
		}
		return "Debugging output disabled!";
	}
}
?>